{
    ColCalc - Una Calcolatrice per il Codice a Colori
    Copyright (C) 2000,2001 Giuseppe Perotti, I1EPJ

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
	 but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}
unit Resval;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, Menus, Colcabt, Stdval, FStd, Aiuto,
  Mask, FCodCol, Spin, GNULic;

type
  TMainForm = class(TForm)
    Shape1: TShape;
	 Banda1: TShape;
    Banda2: TShape;
    Banda3: TShape;
    Banda4: TShape;
    Banda5: TShape;
    Label2: TLabel;
	 BCol2Val: TButton;
    BVal2Col: TButton;
    Label3: TLabel;
    Shape4: TShape;
	 Shape3: TShape;
    Value: TEdit;
    Toll: TEdit;
    BNextVal: TButton;
    MainMenu1: TMainMenu;
    Aiuto1: TMenuItem;
    Banda6: TShape;
    CoeffT: TEdit;
    Label1: TLabel;
    Standard1: TMenuItem;
	 Valorinormalizzati1: TMenuItem;
    SerieE6: TMenuItem;
    SerieE12101: TMenuItem;
    SerieE2451: TMenuItem;
    SerieE481: TMenuItem;
    SerieE9621: TMenuItem;
    Serie1: TMenuItem;
    Opzioni1: TMenuItem;
    SoloStd: TMenuItem;
    SpinButton1: TSpinButton;
	 SpinButton2: TSpinButton;
	 BPrevVal: TButton;
	 Shape6: TShape;
	 Shape2: TShape;
	 Shape5: TShape;
	 SpinButton3: TSpinButton;
	 File1: TMenuItem;
	 Esci2: TMenuItem;
	 Aiuto2: TMenuItem;
	 Informazionisu2: TMenuItem;
	 GNUPublicLicense1: TMenuItem;
	 AutRic: TMenuItem;
    SerieE3: TMenuItem;

	procedure Banda1MouseDown(Sender: TObject; Button: TMouseButton;
		Shift: TShiftState; X, Y: Integer);
	procedure FormCreate(Sender: TObject);
	procedure Banda2MouseDown(Sender: TObject; Button: TMouseButton;
	   Shift: TShiftState; X, Y: Integer);
	procedure Banda3MouseDown(Sender: TObject; Button: TMouseButton;
	   Shift: TShiftState; X, Y: Integer);
	procedure Banda4MouseDown(Sender: TObject; Button: TMouseButton;
	   Shift: TShiftState; X, Y: Integer);
	procedure Banda5MouseDown(Sender: TObject; Button: TMouseButton;
	   Shift: TShiftState; X, Y: Integer);
	procedure Banda6MouseDown(Sender: TObject; Button: TMouseButton;
	   Shift: TShiftState; X, Y: Integer);
	procedure BVal2ColClick(Sender: TObject);
	procedure BCol2ValClick(Sender: TObject);
	procedure BNextValClick(Sender: TObject);
	procedure Esci1Click(Sender: TObject);
	procedure Informazionisu1Click(Sender: TObject);
	procedure SerieE6Click(Sender: TObject);
	procedure SerieE12Click(Sender: TObject);
	procedure SerieE24Click(Sender: TObject);
	procedure SerieE48Click(Sender: TObject);
	procedure SerieE96Click(Sender: TObject);
	procedure SerieE192Click(Sender: TObject);
	procedure Aiuto1Click(Sender: TObject);
	procedure CodiceacoloriClick(Sender: TObject);
	procedure SoloStdClick(Sender: TObject);
	procedure TollDownClick(Sender: TObject);
	procedure TollUpClick(Sender: TObject);
	procedure BPrevValClick(Sender: TObject);
	procedure CTUpClick(Sender: TObject);
	procedure CTDownClick(Sender: TObject);
	procedure FormResize(Sender: TObject);
	procedure GNUPublicLicense1Click(Sender: TObject);
	procedure AutRicClick(Sender: TObject);
	procedure ValueExit(Sender: TObject);
	 procedure TollExit(Sender: TObject);
	 procedure CoeffTExit(Sender: TObject);
    procedure ValueKeyPress(Sender: TObject; var Key: Char);
    procedure TollKeyPress(Sender: TObject; var Key: Char);
    procedure CoeffTKeyPress(Sender: TObject; var Key: Char);
    procedure SerieE3Click(Sender: TObject);

  private
	hOldFont, hFont: hFont;
	{ Private declarations }
	procedure Formatta(x:real; var s: string);
	procedure TogliRumenta(var sv: string);
	procedure TrovaColori(Valore, Toll: real; CoefT: integer);
	function pow10(x: integer): real;
	function TrovaMolt(Valore, Toll: real): integer;
	function TrovaToll(Toll: real): integer;
	function TrovaCoeffT(CoefT: integer): integer;
	function LeggiValori(var Valore: real; var Tolleranza: real; var CoefT: integer): integer;
	function Standardizza(Valore, Tolleranza: real): real;
	procedure CalcCol;
	procedure CalcVal;

  public
	 { Public declarations }
  end;

var
  MainForm: TMainForm;
  B1,B2,B3,B4,B5,B6: Integer;
  StdIndex,TollIndex,CTIndex: integer;
  Colori: array[0..19] of TColor;
  Valori: array[0..11] of integer;
  Tolleranze: array[0..9] of string;
  CoeffTemp: array[0..7] of string;
  ColCoeffTemp: array[0..7] of TColor;
  SoloStandard, AutoRic: Boolean;
  OH, OW: Longint;
  Xs: array[1..40] of Longint;
  Ys: array[1..40] of Longint;
  Ws: array[1..40] of Longint;
  Hs: array[1..40] of Longint;
  PrevHeight, PrevWidth: longint;

implementation

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);

var i: integer;

begin

  Value.Text := '1.0 W';
  Toll.Text := '20%';

  { Save original window size and components size and positions for
    later calculations. Warning: here's fixed array and it's supposed
    that no component is created or deleted at run-time. There is
	 more elegant solutions but this is just for simplicity. }

  for i := 0 to ComponentCount - 1 do
	 if Components[i] is TControl then begin
      Xs[i] := TControl(Components[i]).Left;
      Ys[i] := TControl(Components[i]).Top;
      Ws[i] := TControl(Components[i]).Width;
      Hs[i] := TControl(Components[i]).Height;
    end;

  { Scale window so that it's size compared to screen size is same
	 as designed. Note that divisors here are your desing-time
    screen dimensions. }
  OH := ClientHeight;
  OW := ClientWidth;
  Height := Screen.Height * longint(371) div 600;
  Width := Screen.Width  * longint(640) div 800;
end;

procedure TMainForm.Banda1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);

begin
	case Button of
		mbLeft: begin
			B1 := (B1+1) mod 10;
			if B1=0 then B1:=1;
		end;
		mbRight: begin
			B1 := (B1-1) mod 10;
			if B1<1 then B1:=9;
		end;
	end;
	Banda1.Brush.Color := Colori[B1];
	if AutoRic then begin
		 CalcVal;
	end;
end;


procedure TMainForm.Banda2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
	case Button of
		mbLeft: begin
			B2 := (B2+1) mod 10;
		end;
		mbRight: begin
			B2 := (B2-1);
			if B2 < 0 then B2 := 9;
		end;
	end;
	Banda2.Brush.Color := Colori[B2];
	if AutoRic then begin
		 CalcVal;
	end;
end;


procedure TMainForm.Banda3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);

begin
	case Button of
		mbLeft: begin
			if B4 = 12 then begin
				B3 := (B3+1) mod 12;
				if B3 = 8 then B3 := 10;
			end else begin
				B3 := (B3+1) mod 10;
			end;
		end;
		mbRight: begin
			B3 := (B3-1);
			if B4 = 12 then begin
				if B3 < 0 then B3 := 11;
				if B3 = 9 then B3 := 7;
			end else begin
				if B3 < 0 then B3 := 9;
			end;
		end;
	end;
	Banda3.Brush.Color := Colori[B3];
	if AutoRic then begin
		 CalcVal;
	end;
end;


procedure TMainForm.Banda4MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);

begin
	case Button of
		mbLeft: begin
			B4 := (B4+1) mod 13;
		end;
		mbRight: begin
		   B4 := (B4-1);
		   if B4 < 0 then B4 := 12;
		end;
	end;
	  if B4 < 12 then begin
		 Banda4.Pen.Style := psClear;
		 Banda4.Brush.Style := bsSolid;
		 Banda4.Brush.Color := Colori[B4];
		 if B3 > 9 then begin
			B3 := 0;
			Banda3.Brush.Color := Colori[B4];
		 end;
		 if (B5 = 7) or (B5 < 2) then begin
			B5 := 2;
			Banda5.Brush.Color := Colori[B5+10];
		 end;
	  end else begin
         Banda4.Pen.Style := psDot;
         Banda4.Brush.Style := bsClear;
         B5 := 1;
         Banda5.Brush.Color := Colori[B5+10];
         Banda6.Pen.Style := psDot;
         Banda6.Brush.Style := bsClear;
     end;
	if AutoRic then begin
		 CalcVal;
	end;
end;

procedure TMainForm.Banda5MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);

begin
	case Button of
		mbLeft: begin
			B5 := ((B5+1) mod 10);
		end;
		mbRight: begin
			B5 := (B5-1);
			if B5 < 0 then B5 := 9;
		end;
	end;
	if B5 > 7 then begin
		Banda4.Pen.Style := psDot;
		Banda4.Brush.Style := bsClear;
		Banda5.Pen.Style := psDot;
		Banda5.Brush.Style := bsClear;
		Banda6.Pen.Style := psDot;
		Banda6.Brush.Style := bsClear;
		B4 := 12;
		B6 := 8;
	  end else begin
		  if B5 > 1 then begin
			 Banda4.Pen.Style := psClear;
			 Banda4.Brush.Style := bsSolid;
			 if B4 = 12 then begin
				B4 := 0;
				Banda4.Brush.Color := COlori[B4];
			 end;
			 if B3 > 9 then begin
				B3 := 0;
				Banda3.Brush.Color := Colori[B3];
			 end;
		  end else begin
			 Banda4.Pen.Style := psDot;
			 Banda4.Brush.Style := bsClear;
			 B4 := 12;
		  end;
		  Banda5.Pen.Style := psClear;
		  Banda5.Brush.Style := bsSolid;
		  Banda5.Brush.Color := Colori[B5+10];
	  end;
	if AutoRic then begin
		 CalcVal;
	end;
end;


procedure TMainForm.Banda6MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);

begin
	case Button of
		mbLeft: begin
			B6 := ((B6+1) mod 9);
		end;
		mbRight: begin
			B6 := (B6-1);
			if B6 < 0 then B6 := 8;
		end;
	end;
	  if B6 = 8 then begin
		  Banda6.Pen.Style := psDot;
		  Banda6.Brush.Style := bsClear;
	  end else begin
		   Banda6.Pen.Style := psClear;
		   Banda6.Brush.Style := bsSolid;
		   Banda6.Brush.Color := ColCoeffTemp[B6];
		  if B3 > 9 then begin
			 B3 := 0;
			 Banda3.Brush.Color := Colori[B3];
		  end;
		  if B4 = 12 then begin
			 B4 := 0;
			 Banda4.Pen.Style := psClear;
			 Banda4.Brush.Style := bsSolid;
			 Banda4.Brush.Color := Colori[B4];
		  end;
		  if (B5 = 7) or (B5 < 2) then begin
			 B5 := 2;
			 Banda5.Pen.Style := psClear;
			 Banda5.Brush.Style := bsSolid;
			 Banda5.Brush.Color := Colori[B5+10];
		  end;
	  end;
	if AutoRic then begin
		 CalcVal;
	end;
end;


procedure TMainForm.Formatta(x:real; var s: string);

var um:string;

begin
     if x < 1000 then
          um := ' W'
     else if x < 1000000 then begin
          um := ' KW';
          x := x/1000;
     end else if x < 1000000000 then begin
          um := ' MW';
          x := x/1000000;
     end else begin
		  um := ' GW';
		  x := x/1000000000;
     end;

     if x < 1 then begin
        if B4 = 12 then begin
           Str(x:3:2, s);
        end else begin
           Str(x:3:3, s);
        end;
	  end else if x < 10 then begin
        if B4 = 12 then begin
           Str(x:3:1, s);
        end else begin
           Str(x:3:2, s);
        end;
     end else if x < 100 then begin
        if B4 = 12 then begin
           Str(x:3:0, s);
        end else begin
			Str(x:3:1, s);
		 end;
     end else begin
           Str(x:3:0, s);
     end;
     s := s+um;
end;


function TMainForm.pow10(x: integer): real;

var ris: real;
    i: integer;

begin
     ris := 1;
     for i := 1 to abs(x) do begin
           ris := 10*ris;
     end;
     if x < 0 then ris := 1/ris;
	  pow10 := ris;
end;


procedure TMainForm.TogliRumenta(var sv: string);

var p: integer;

begin
     repeat
		   p := Pos('W',sv);
          if p <> 0 then Delete(sv,p,255);
     until p = 0;
     repeat
          p := Pos(' ',sv);
          if p <> 0 then Delete(sv,p,1);
     until p = 0;
     repeat
          p := Pos('%',sv);
          if p <> 0 then Delete(sv,p,1);
	  until p = 0;
	  repeat
          p := Pos('ppm',sv);
          if p <> 0 then Delete(sv,p,255);
     until p = 0;
end;


procedure TMainForm.TrovaColori(Valore, Toll: real; CoefT: integer);

var SVal: string;

begin
	  Str((Valore*100):3:2,SVal);
	  if Toll >= 5 then begin
		 Banda4.Pen.Style := psDot;
		 Banda5.Pen.Style := psDot;
		 Banda6.Pen.Style := psDot;
		 Banda4.Brush.Style := bsClear;
		 Banda5.Brush.Style := bsClear;
		 Banda6.Brush.Style := bsClear;
		 B1 := Ord(SVal[1])-Ord('0');
		 B2 := Ord(SVal[2])-Ord('0');
		 B3 := TrovaMolt(Valore,Toll);
		 B4 := 12;
		 B5 := TrovaToll(Toll);
		 B6 := 8;
		 Banda1.Brush.Color := Colori[B1];
		 Banda2.Brush.Color := Colori[B2];
		 Banda3.Brush.Color := Colori[B3];
		 Banda5.Brush.Color := Colori[B5+10];
	  end else begin
		 Banda4.Pen.Style := psClear;
		 Banda5.Pen.Style := psClear;
		 Banda4.Brush.Style := bsSolid;
		 Banda5.Brush.Style := bsSolid;
		 B1 := Ord(SVal[1])-Ord('0');
		 B2 := Ord(SVal[2])-Ord('0');
		 B3 := Ord(SVal[3])-Ord('0');;
		 B4 := TrovaMolt(Valore,Toll);
		 B5 := TrovaToll(Toll);
		 B6 := TrovaCoeffT(CoefT);
		 if B6 <> -1 then begin
			Banda6.Pen.Style := psClear;
			Banda6.Brush.Style := bsSolid;
			Banda6.Brush.Color := ColCoeffTemp[B6];
		 end else begin
           Banda6.Pen.Style := psDot;
           Banda6.Brush.Style := bsClear;
        end;
		 Banda1.Brush.Color := Colori[B1];
        Banda2.Brush.Color := Colori[B2];
        Banda3.Brush.Color := Colori[B3];
        Banda4.Brush.Color := Colori[B4];
        Banda5.Brush.Color := Colori[B5+10];
     end;
end;


function TMainForm.TrovaMolt(Valore, Toll: real): integer;

begin
	 TrovaMolt := 0;
	 if Valore < 1 then begin
		 TrovaMolt := 10;
	 end else if Valore < 10 then begin
		 if Toll < 5 then TrovaMolt := 10 else TrovaMolt := 11;
	 end else if Valore < 100 then begin
		 if Toll < 5 then TrovaMolt := 11 else TrovaMolt := 0;
	 end else if Valore < 1000 then begin
		 if Toll < 5 then TrovaMolt := 0 else TrovaMolt := 1;
	 end else if Valore < 10000 then begin
		 if Toll < 5 then TrovaMolt := 1 else TrovaMolt := 2;
	 end else if Valore < 100000 then begin
		 if Toll < 5 then TrovaMolt := 2 else TrovaMolt := 3;
	 end else if Valore < 1000000 then begin
		 if Toll < 5 then TrovaMolt := 3 else TrovaMolt := 4;
	 end else if Valore < 10000000 then begin
		 if Toll < 5 then TrovaMolt := 4 else TrovaMolt := 5;
	 end else if Valore < 100000000 then begin
		 if Toll < 5 then TrovaMolt := 5 else TrovaMolt := 6;
	 end else if Valore < 1000000000 then begin
		 if Toll < 5 then TrovaMolt := 6 else TrovaMolt := 7;
	 end else if Valore < 1e10 then begin
		 if Toll < 5 then TrovaMolt := 7 else TrovaMolt := 8;
	 end else if Valore < 1e11 then begin
		 if Toll < 5 then TrovaMolt := 8 else TrovaMolt := 9;
	 end;
end;


function TMainForm.TrovaToll(Toll: real): integer;

var n,err: integer;
	 t: real;
	 s: string;

begin
	  TrovaToll := -1;
	  for n := 0 to 9 do begin
		  S := Tolleranze[n];
		  TogliRumenta(s);
		  Val(s, t, err);
		  if Toll = t then begin
			 if (Toll = 20) or (Toll = 50) then begin
				Banda5.Pen.Style := psDot;
			 end else begin
				Banda5.Pen.Style := psClear;
			 end;
			 Banda5.Brush.Color := Colori[n+10];
			 TrovaToll := n;
		  end;
	  end;
end;

function TMainForm.TrovaCoeffT(CoefT: integer): integer;

var n,err,t: integer;
    s: string;

begin
	  if CoefT = -1 then
          TrovaCoeffT := -1
     else
		   TrovaCoeffT := -2;

     for n := 0 to 7 do begin
         s := CoeffTemp[n];
         TogliRumenta(s);
		  Val(s, t, err);
		  if CoefT = t then begin
            Banda6.Brush.Color := ColCoeffTemp[n];
            TrovaCoeffT := n;
         end;
     end;
end;


function TMainForm.LeggiValori(var Valore: real; var Tolleranza: real; var CoefT: integer): integer;

var sv, st, sc: string;
	 p, err: integer;

begin
	  sv := Value.Text;
     st := Toll.Text;
     sc := CoeffT.Text;
     TogliRumenta(st);
     if st <> '' then
		 Val(st,Tolleranza,err)
	  else
         Tolleranza := 20;

     TogliRumenta(sc);
     if sc <> '' then
        Val(sc,CoefT,err)
     else
         CoefT := -1;

     p := Pos('K',sv);
	  if p <> 0 then begin
		 Delete(sv,p,255);
        TogliRumenta(sv);
        Val(sv,Valore,err);
		 Valore := Valore*1000;
     end else begin
          p := Pos('M',sv);
          if p <> 0 then begin
             Delete(sv,p,255);
			  TogliRumenta(sv);
			  Val(sv,Valore,err);
             Valore := Valore*1000000;
          end else begin
              p := Pos('G',sv);
              if p <> 0 then begin
                 Delete(sv,p,255);
                 TogliRumenta(sv);
                 Val(sv,Valore,err);
                 Valore := Valore*1000000000;
              end else begin
				  TogliRumenta(sv);
				  Val(sv, Valore, err);
              end;
          end;
	  end;
     LeggiValori := err;
end;

procedure TMainForm.CalcVal;
var s: string;
	 Valore,Tolleranza: real;
	 err,CoefTemp: integer;

begin
	  if B4 = 12 then begin
		  Valore := (Valori[B1]*10+Valori[B2])*(pow10(Valori[B3]));
	  end else begin
		  Valore := (Valori[B1]*100+Valori[B2]*10+Valori[B3])*(pow10(Valori[B4]));
	  end;
	  Valore := Valore+1e-5;
	  if SoloStandard then begin
		 s := Tolleranze[B5];
		 TogliRumenta(s);
		 Val(s, Tolleranza, err);
		 if (B6 >= 0) and (B6 <> 8) then begin
			s := CoeffTemp[B6];
			TogliRumenta(s);
			Val(s, CoefTemp, err);
			TrovaCoeffT(CoefTemp);
		 end else begin
			CoefTemp := -1;
		 end;
		 Valore := Standardizza(Valore, Tolleranza);
		 TrovaColori(Valore,Tolleranza,CoefTemp);
	  end;
	  Formatta(Valore,s);
	  Value.Text := s;
	  Toll.Text := Tolleranze[B5];
	  TollIndex := B5;
	  if (B6 >= 0) and (B6 <> 8) then begin
		 CoeffT.Text := CoeffTemp[B6];
		 CTIndex := B6;
	  end else begin
		  CoeffT.text := '';
		  CTIndex := 8;
	  end;
end;

procedure TMainForm.BCol2ValClick(Sender: TObject);
begin
	CalcVal;
end;


function TMainForm.Standardizza(Valore, Tolleranza: real): real;

var n,delta,mindelta,minindex,IVal: integer;
	 IToll,Numval,err,mul: integer;

begin
	  IToll := TrovaToll(Tolleranza);
	  if IToll <> -1 then begin
		 mul := trunc(ln(Valore)/ln(10));
		 Valore := Valore/pow10(mul);
		 IVal := Trunc(Valore*100);
		 if Valore < 1 then IVal := Trunc(Valore*1000);
		 case IToll of
			  0:    NumVal := 12;
			  1:    NumVal := 24;
			  2:    NumVal := 48;
			  3:    NumVal := 96;
			  4,5,
			  6,7:  NumVal := 192;
			  8:    NumVal := 3;
			  9:	NumVal := 6;
		 else
			 NumVal := 24;
		 end;
		 mindelta := 1000;
		 minindex := 0;
		 StdIndex := 0;
		 for n := 1 to NumVal do begin
			 case IToll of
				0:    delta := abs(SE12[n]-IVal);
				1:    delta := abs(SE24[n]-IVal);
				2:    delta := abs(SE48[n]-IVal);
				3:    delta := abs(SE96[n]-IVal);
				4,5,
				6,7:  delta := abs(SE192[n]-IVal);
				8:    delta := abs(SE3[n]-IVal);
				9:	  delta := abs(SE6[n]-IVal);
			 else
				 delta := abs(SE24[IToll]-IVal);
			 end;
			 if delta <= mindelta then begin
				mindelta := delta;
				minindex := n;
				StdIndex := n-1;
			end;
		 end;
		 if Valore < 1 then mul := mul-1;
		 if abs(1000-Ival) < mindelta then begin
			mul := mul+1;
			minindex := 1;
			Stdindex := 0;
		 end;
		 case IToll of
			0:   Standardizza := SE12[minindex]*pow10(mul-2);
			1:   Standardizza := SE24[minindex]*pow10(mul-2);
			2:   Standardizza := SE48[minindex]*pow10(mul-2);
			3:   Standardizza := SE96[minindex]*pow10(mul-2);
			4,5,
			6,7: Standardizza := SE192[minindex]*pow10(mul-2);
			8:   Standardizza := SE3[minindex]*pow10(mul-2);
			9:   Standardizza := SE6[minindex]*pow10(mul-2);
		  else
				 Standardizza := SE24[minindex]*pow10(mul-2);
		 end;
	  end;
end;

procedure TMainForm.CalcCol;

var Valore,Tolleranza: real;
	 CoeffTemperatura: integer;
	 IToll,err: integer;
	 buf: array[0..80] of char;
	 s: string;

begin
	  err := LeggiValori(Valore,Tolleranza,CoeffTemperatura);
	  IToll := TrovaToll(Tolleranza);
	  B6 := TrovaCoeffT(CoeffTemperatura);

	  if (err = 0) and (IToll <> -1) then begin
		 if (Valore < 1) and (Tolleranza < 5) then Valore := 1;
		 Valore := Standardizza(Valore, Tolleranza);
		 Trovacolori(Valore, Tolleranza, CoeffTemperatura);
		 Formatta(Valore,s);
		 Value.Text := s;
		 Toll.Text := Tolleranze[IToll];
		 if B6 = -2 then begin
			StrCopy(buf,'Coefficiente di temperatura non valido!');
			Application.MessageBox(buf,'Errore!', MB_OK+MB_ICONSTOP+MB_DEFBUTTON1);
			B6 := 8;
			Banda6.Pen.Style := psDot;
			Banda6.Brush.Style := bsClear;
			CoeffT.Text := '';
		 end else if B6 = -1 then begin
			 B6 := 8;
		 end else begin
			CoeffT.Text := CoeffTemp[B6];
		 end;
	  end else begin
		 if err <> 0 then begin
			StrCopy(buf,'Valore non valido!');
			Application.MessageBox(buf,'Errore!', MB_OK+MB_ICONSTOP+MB_DEFBUTTON1);
			Value.Text := '';
		 end;
		 if IToll = -1 then begin
			StrCopy(buf,'Tolleranza non valida!');
			Application.MessageBox(buf,'Errore!' , MB_OK+MB_ICONSTOP+MB_DEFBUTTON1);
			Toll.Text := '';
		 end;
	  end;
end;

procedure TMainForm.BVal2ColClick(Sender: TObject);

begin
	CalcCol;
end;


procedure TMainForm.BNextValClick(Sender: TObject);

var NumVal,IToll,mul,err: integer;
    Valore,Tolleranza: real;
    CoeffTemperatura: integer;
    s: string;

begin
     err := LeggiValori(Valore,Tolleranza,CoeffTemperatura);
     IToll := TrovaToll(Tolleranza);
     case IToll of
         0:    NumVal := 12;
         1:    NumVal := 24;
         2:    NumVal := 48;
		  3:    NumVal := 96;
		  4,5,
		  6,7:  NumVal := 192;
		  8:    NumVal := 3;
		  9:	NumVal := 6;
	  else
		 NumVal := 24;
	  end;
	  StdIndex := (StdIndex + 1) mod NumVal;
	  mul := trunc(ln(Valore)/ln(10));
	  if ln(valore) < 0 then mul := -1;
	  case IToll of
		 0:   Valore := SE12[StdIndex+1]*pow10(mul-2);
		 1:   Valore := SE24[StdIndex+1]*pow10(mul-2);
		 2:   Valore := SE48[StdIndex+1]*pow10(mul-2);
		 3:   Valore := SE96[StdIndex+1]*pow10(mul-2);
		 4,5,
		 6,7: Valore := SE192[StdIndex+1]*pow10(mul-2);
		 8:   Valore := SE3[StdIndex+1]*pow10(mul-2);
		 9:   Valore := SE6[StdIndex+1]*pow10(mul-2);
	  else
		 Valore := SE24[StdIndex+1]*pow10(mul-2);
	  end;
	  if StdIndex = 0 then Valore := 10*Valore;
	  If Valore >= 1E9 then begin
		 if Tolleranza < 5 then
			Valore := 1
		 else
			Valore := 0.1
	  end;
	  Valore := Valore+1E-5;
	  Trovacolori(Valore, Tolleranza, CoeffTemperatura);
	  Toll.Text := Tolleranze[IToll];
	  Formatta(Valore,s);
	  Value.Text := s;
end;


procedure TMainForm.Esci1Click(Sender: TObject);
begin
	  Halt;
end;

procedure TMainForm.Informazionisu1Click(Sender: TObject);
begin
	 AboutBox.Visible := True;
end;

procedure TMainForm.SerieE3Click(Sender: TObject);
var n: integer;
	 s: string;

begin
	  FrStd.Std.Clear;
	  for n := 1 to 3 do begin
		  Str(SE3[n],s);
		  FrStd.Std.Items.Add(s);
	  end;
	  FrStd.Caption := 'Serie E3';
	  FrStd.Visible := True;
end;


procedure TMainForm.SerieE6Click(Sender: TObject);

var n: integer;
	 s: string;

begin
	  FrStd.Std.Clear;
	  for n := 1 to 6 do begin
		  Str(SE6[n],s);
		  FrStd.Std.Items.Add(s);
	  end;
	  FrStd.Caption := 'Serie E6';
	  FrStd.Visible := True;
end;

procedure TMainForm.SerieE12Click(Sender: TObject);

var n: integer;
	 s: string;

begin
	  FrStd.Std.Clear;
	  for n := 1 to 12 do begin
		  Str(SE12[n],s);
		  FrStd.Std.Items.Add(s);
	  end;
	  FrStd.Caption := 'Serie E12';
	  FrStd.Visible := True;
end;

procedure TMainForm.SerieE24Click(Sender: TObject);

var n: integer;
	 s: string;

begin
	 FrStd.Std.Clear;
	 for n := 1 to 24 do begin
		  Str(SE24[n],s);
		  FrStd.Std.Items.Add(s);
	  end;
	  FrStd.Caption := 'Serie E24';
	  FrStd.Visible := True;
end;

procedure TMainForm.SerieE48Click(Sender: TObject);

var n: integer;
	 s: string;

begin
	 FrStd.Std.Clear;
	 for n := 1 to 48 do begin
		  Str(SE48[n],s);
		  FrStd.Std.Items.Add(s);
	  end;
	  FrStd.Caption := 'Serie E48';
	  FrStd.Visible := True;
end;

procedure TMainForm.SerieE96Click(Sender: TObject);

var n: integer;
	 s: string;

begin
	 FrStd.Std.Clear;
	 for n := 1 to 96 do begin
		  Str(SE96[n],s);
		  FrStd.Std.Items.Add(s);
	  end;
	  FrStd.Caption := 'Serie E96';
	  FrStd.Visible := True;
end;

procedure TMainForm.SerieE192Click(Sender: TObject);

var n: integer;
	 s: string;

begin
	 FrStd.Std.Clear;
	 for n := 1 to 192 do begin
		  Str(SE192[n],s);
		  FrStd.Std.Items.Add(s);
	  end;
	  FrStd.Caption := 'Serie E192';
	  FrStd.Visible := True;
end;

procedure TMainForm.Aiuto1Click(Sender: TObject);
begin
	  HelpForm.Visible := True;
end;

procedure TMainForm.CodiceacoloriClick(Sender: TObject);
begin
	  CodCol.Visible := True;
end;

procedure TMainForm.SoloStdClick(Sender: TObject);

begin
	SoloStandard := not(SoloStandard);
	SoloStd.Checked := SoloStandard;
	CalcCol;
end;

procedure TMainForm.TollDownClick(Sender: TObject);

var    Valore,Tolleranza: real;
		CoeffTemperatura,err: integer;
		s: string;

begin
	  err := LeggiValori(Valore,Tolleranza,CoeffTemperatura);
	  TollIndex := (TollIndex+1);
	  if TollIndex > 9 then TollIndex := 0;
	  Toll.Text := Tolleranze[TollIndex];
	  err := LeggiValori(Valore,Tolleranza,CoeffTemperatura);
	  if (Valore < 1) and (Tolleranza < 5) then Valore := 1;
	  Valore := Standardizza(Valore, Tolleranza);
	  Trovacolori(Valore, Tolleranza, CoeffTemperatura);
	  Formatta(Valore,s);
	  Value.Text := s;
	  if B6 > 0 then CoeffT.Text := CoeffTemp[B6];
end;

procedure TMainForm.TollUpClick(Sender: TObject);

var    Valore,Tolleranza: real;
		CoeffTemperatura, err: integer;
		s: string;

begin
	  TollIndex := (TollIndex - 1);
	  if TollIndex < 0 then TollIndex := 9;
	  Toll.Text := Tolleranze[TollIndex];
	  err := LeggiValori(Valore,Tolleranza,CoeffTemperatura);
	  if (Valore < 1) and (Tolleranza < 5) then Valore := 1;
	  Valore := Standardizza(Valore, Tolleranza);
	  Trovacolori(Valore, Tolleranza, CoeffTemperatura);
	  Formatta(Valore,s);
	  Value.Text := s;
	  if B6 > 0 then CoeffT.Text := CoeffTemp[B6];
end;

procedure TMainForm.BPrevValClick(Sender: TObject);

var NumVal,IToll,mul,err: integer;
    Valore,Tolleranza: real;
	 CoeffTemperatura: integer;
	 s: string;

begin
	  err := LeggiValori(Valore,Tolleranza,CoeffTemperatura);
	  if Tolleranza < 5 then begin
		 if Valore < 1.01 then Valore := 9.95E9;
	  end else begin
		  If Valore < 0.11 then Valore := 1E9;
	  end;
	  IToll := TrovaToll(Tolleranza);
	  case IToll of
		  0:    NumVal := 12;
		  1:    NumVal := 24;
		  2:    NumVal := 48;
		  3:    NumVal := 96;
		  4,5,
		  6,7:  NumVal := 192;
		  8:    NumVal := 3;
		  9:	Numval := 6;
	  else
		 NumVal := 24;
	  end;
	  StdIndex := StdIndex - 1;
	  if StdIndex < 0 then StdIndex := NumVal-1;
	  mul := trunc(ln(Valore)/ln(10));
     if Valore < 1 then mul := -1;
	  case IToll of
		 0:   Valore := SE12[StdIndex+1]*pow10(mul-2);
		 1:   Valore := SE24[StdIndex+1]*pow10(mul-2);
		 2:   Valore := SE48[StdIndex+1]*pow10(mul-2);
		 3:   Valore := SE96[StdIndex+1]*pow10(mul-2);
		 4,5,
		 6,7: Valore := SE192[StdIndex+1]*pow10(mul-2);
		 8:   Valore := SE3[StdIndex+1]*pow10(mul-2);
		 9:   Valore := SE6[StdIndex+1]*pow10(mul-2);
	  else
		 Valore := SE24[StdIndex+1]*pow10(mul-2);
	  end;
	  if StdIndex = NumVal -1 then Valore := Valore/10;
	  Trovacolori(Valore, Tolleranza, CoeffTemperatura);
	  Toll.Text := Tolleranze[IToll];
	  Formatta(Valore,s);
	  Value.Text := s;
	  if B6 > 0 then CoeffT.Text := CoeffTemp[B6];
end;

procedure TMainForm.CTUpClick(Sender: TObject);

var    Valore,Tolleranza: real;
		CoeffTemperatura,err,IToll: integer;
       s: string;

begin
     CTIndex := CTIndex - 1;
     if CTIndex < 0 then CTIndex := 8;
	  if CTIndex < 8 then
        CoeffT.Text := CoeffTemp[CTIndex]
     else
        CoeffT.Text := '';
     err := LeggiValori(Valore,Tolleranza,CoeffTemperatura);
     if Tolleranza > 2 then begin
			Tolleranza := 2;
           TollIndex := 2;
			B5 := 2;
	  end;
     Valore := Standardizza(Valore, Tolleranza);
	  Trovacolori(Valore, Tolleranza, CoeffTemperatura);
     IToll := TrovaToll(Tolleranza);
     Toll.Text := Tolleranze[IToll];
	  Formatta(Valore,s);
     Value.Text := s;
end;

procedure TMainForm.CTDownClick(Sender: TObject);

var    Valore,Tolleranza: real;
    	CoeffTemperatura,err,IToll: integer;
       s: string;

begin
     CTIndex := (CTIndex +1);
	  if CTIndex > 8 then CTIndex := 0;
     if CTIndex < 8 then
		 CoeffT.Text := CoeffTemp[CTIndex]
	  else
        CoeffT.Text := '';
	  err := LeggiValori(Valore,Tolleranza,CoeffTemperatura);
     if Tolleranza > 2 then begin
     		Tolleranza := 2;
			TollIndex := 2;
           B5 := 2;
	  end;
     Valore := Standardizza(Valore, Tolleranza);
     Trovacolori(Valore, Tolleranza, CoeffTemperatura);
	  IToll := TrovaToll(Tolleranza);
	  Toll.Text := Tolleranze[IToll];
     Formatta(Valore,s);
     Value.Text := s;
end;

procedure TMainForm.FormResize(Sender: TObject);

    var i: integer;
	 c: TControl;

begin
  {
   Create font that size is relative to window size and delete
   old font.
  }
  hFont := CreateFont(ClientHeight div 4, ClientWidth div 18, 0, 0,
                      FW_BOLD, 0, 0, 0, 1, OUT_DEVICE_PRECIS, 0,
                      PROOF_QUALITY, FF_DONTCARE, 'Symbol');
  hOldFont := Value.Font.Handle;
  Value.Font.Handle := hFont;
  DeleteObject(hOldFont);

  hFont := CreateFont(ClientHeight div 20, ClientWidth div 75, 0, 0,
                      FW_BOLD, 0, 0, 0, 1, OUT_DEVICE_PRECIS, 0,
                      PROOF_QUALITY, FF_DONTCARE, 'Arial');
  hOldFont := MainForm.Font.Handle;
  MainForm.Font.Handle := hFont;
  DeleteObject(hOldFont);

  hFont := CreateFont(ClientHeight div 4, ClientWidth div 18, 0, 0,
                      FW_BOLD, 0, 0, 0, 1, OUT_DEVICE_PRECIS, 0,
					   PROOF_QUALITY, FF_DONTCARE, 'Symbol');
  hOldFont := Toll.Font.Handle;
  Toll.Font.Handle := hFont;
  DeleteObject(hOldFont);

  hFont := CreateFont(ClientHeight*10 div 42, ClientWidth*10 div 265, 0, 0,
                      FW_NORMAL, 0, 0, 0, 1, OUT_DEVICE_PRECIS, 0,
                      PROOF_QUALITY, FF_DONTCARE, 'Times New Roman');
  hOldFont := CoeffT.Font.Handle;
  CoeffT.Font.Handle := hFont;
  DeleteObject(hOldFont);

  hFont := CreateFont(ClientHeight div 8, ClientWidth div 45, 0, 0,
                      FW_NORMAL, 0, 0, 0, 1, OUT_DEVICE_PRECIS, 0,
                      PROOF_QUALITY, FF_DONTCARE, 'Times New Roman');
  hOldFont := Label1.Font.Handle;
  Label1.Font.Handle := hFont;
  DeleteObject(hOldFont);

  hFont := CreateFont(ClientHeight div 8, ClientWidth div 45, 0, 0,
					   FW_NORMAL, 0, 0, 0, 1, OUT_DEVICE_PRECIS, 0,
                      PROOF_QUALITY, FF_DONTCARE, 'Times New Roman');
  hOldFont := Label2.Font.Handle;
  Label2.Font.Handle := hFont;
  DeleteObject(hOldFont);

  hFont := CreateFont(ClientHeight div 8, ClientWidth div 45, 0, 0,
                      FW_NORMAL, 0, 0, 0, 1, OUT_DEVICE_PRECIS, 0,
					   PROOF_QUALITY, FF_DONTCARE, 'Times New Roman');
  hOldFont := Label3.Font.Handle;
  Label3.Font.Handle := hFont;
  DeleteObject(hOldFont);

  { Here's actual component scaling. }
  for i := 0 to ComponentCount - 1 do begin
    if Components[i] is TControl then begin
      c := TControl(Components[i]);
	   c.Left   := Xs[i] * Longint(ClientWidth) div OW;
	   c.Top    := Ys[i] * Longint(ClientHeight) div OH;
      c.Width  := Ws[i] * Longint(ClientWidth) div OW;
	   c.Height := Hs[i] * Longint(ClientHeight) div OH;
    end;
  { Finally save window dimensions }
  PrevWidth  := ClientWidth;
  PrevHeight := ClientHeight;
 end;
end;

procedure TMainForm.GNUPublicLicense1Click(Sender: TObject);
begin
		GNULicFrm.Visible := True;
end;

procedure TMainForm.AutRicClick(Sender: TObject);
begin
	 AutoRic := not(AutoRic);
	 AutRic.Checked := AutoRic;
end;

procedure TMainForm.ValueExit(Sender: TObject);
begin
	if AutoRic then begin
		CalcCol;
	end;
end;

procedure TMainForm.TollExit(Sender: TObject);
begin
	if AutoRic then begin
		CalcCol;
	end;
end;

procedure TMainForm.CoeffTExit(Sender: TObject);
begin
	if AutoRic then begin
		CalcCol;
	end;
end;

procedure TMainForm.ValueKeyPress(Sender: TObject; var Key: Char);
begin
	if Key = chr(13) then begin
		CalcCol;
		Toll.SetFocus;
	end;
end;

procedure TMainForm.TollKeyPress(Sender: TObject; var Key: Char);
begin
	if Key = chr(13) then begin
		CalcCol;
		CoeffT.SetFocus;
	end;
end;

procedure TMainForm.CoeffTKeyPress(Sender: TObject; var Key: Char);
begin
	if Key = chr(13) then begin
		CalcCol;
		Value.SetFocus;
	end;
end;

initialization
  B1 := 1;
  B2 := 0;
  B3 := 11;
  B4 := 12;
  B5 := 9;
  B6 := 8;
  StdIndex := 0;
  TollIndex := 9;
  CTIndex := 8;
  SoloStandard := True;
  AutoRic := False;

  Colori[0] := clBlack;
  Colori[1] := clMaroon;
  Colori[2] := clRed;
  Colori[3] := $0099FF;
  Colori[4] := clYellow;
  Colori[5] := clGreen;
  Colori[6] := clBlue;
  Colori[7] := clPurple;
  Colori[8] := clGray;
  Colori[9] := clWhite;
  Colori[10] := $D4D4D4;
  Colori[11] := $00CCFF;
  Colori[12] := clRed;
  Colori[13] := clMaroon;
  COlori[14] := clGreen;
  Colori[15] := clBlue;
  Colori[16] := clPurple;
  Colori[17] := clGray;
  Colori[18] := $C7E4DF;
  Colori[19] := $C7E4DF;

  Valori[0] := 0;
  Valori[1] := 1;
  Valori[2] := 2;
  Valori[3] := 3;
  Valori[4] := 4;
  Valori[5] := 5;
  Valori[6] := 6;
  Valori[7] := 7;
  Valori[8] := 8;
  Valori[9] := 9;
  Valori[10] := -2;
  Valori[11] := -1;

  Tolleranze[0] := '10%';
  Tolleranze[1] := '5%';
  Tolleranze[2] := '2%';
  Tolleranze[3] := '1%';
  Tolleranze[4] := '0.5%';
  Tolleranze[5] := '0.25%';
  Tolleranze[6] := '0.1%';
  Tolleranze[7] := '0.05%';
  Tolleranze[8] := '50%';
  Tolleranze[9] := '20%';

  CoeffTemp[0] := '200ppm';
  CoeffTemp[1] := '100ppm';
  CoeffTemp[2] := '50ppm';
  CoeffTemp[3] := '15ppm';
  CoeffTemp[4] := '25ppm';
  CoeffTemp[5] := '10ppm';
  CoeffTemp[6] := '5ppm';
  CoeffTemp[7] := '1ppm';

  ColCoeffTemp[0] := clBlack;      { da alcune fonti non  previsto }
  ColCoeffTemp[1] := clMaroon;
  ColCoeffTemp[2] := clRed;
  ColCoeffTemp[3] := $0099FF;;
  ColCoeffTemp[4] := clYellow;
  ColCoeffTemp[5] := clBlue;
  ColCoeffTemp[6] := clPurple;
  ColCoeffTemp[7] := clWhite;		{ alcune fonti sostengono che sia GRIGIO }
end.
